#!/bin/bash
sample_dir="solved_clusters/"
output_dir="dat/"
bitmask=32

if [[ "$1" != "" ]]; then
	sample_dir="$1"
	# make sure the sample_dir has a trailing slash
	if [[ "${sample_dir##*/}" != "" ]]; then
		sample_dir="${sample_dir}/"
	fi
fi
if [[ "$2" != "" ]]; then
	output_dir=$2
	# make sure the output_dir has a trailing slash
	if [[ "${output_dir##*/}" != "" ]]; then
		output_dir="${output_dir}/"
	fi
fi
if [[ "$3" != "" ]]; then
	bitmask=$3
	# check to make sure bitmask is numeric
	echo $((bitmask+1)) &> /dev/null
	if [[ $? -ne 0 ]]; then
		echo
		echo Error: bitmask must be numeric.  Exiting...
		echo
		exit
	fi
fi

rm -f ${output_dir}*.csv
mkdir -p $output_dir

for file in `find $sample_dir -iname *.wav`; do
	path=${file%/*} # get just the path to the .wav file
	output_filename=`echo ${file#*/} | sed 's|/|_|g'`
	word=${path##*/} # get the last subdirectory, that's the word
	echo sox "$file" -n stat -s 1 -freq \&\> "${output_dir}${output_filename}.dat" 
	sox "$file" -n stat -s 1 -freq &> "${output_dir}${output_filename}.dat" 
	python ../splot.py ${output_dir}${output_filename}.dat $bitmask >> ${output_dir}$word.csv
	rm ${output_dir}${output_filename}.dat
done

