#!/usr/bin/python
#Dependencies: sox libsox-fmt-all octave curl
#Additionally, if you're on python2.6: python-argparse python-imaging
import os, argparse
import solver, fuckit_splitter, nnsolver
import generic_downloader

parser = argparse.ArgumentParser(description="Solves a captcha given the challenge token")
parser.add_argument('challenge', type=str, metavar='challenge or sitekey', help='The challenge token from recaptcha to solve (or if -s is given the site key)')
parser.add_argument('-s', required=False, action='store_true', help='If given, download a challenge using the site key and solve the corresponding captcha')
parser.add_argument('-proxy_host', required=False, default="", type=str, metavar='proxy_host', help='Use the specified proxy host')
parser.add_argument('-proxy_port', required=False, default="8118", type=str, metavar='proxy_host', help='Use the specified proxy port')

args = parser.parse_args()
splitter = fuckit_splitter.FuckItSplitter()
the_solver = nnsolver.NnSolver()
downloader = generic_downloader.GenericDownloader(args.proxy_host, args.proxy_port)
if args.s:
    downloader.set_site_key(args.challenge)

captcha_solver = solver.CaptchaSolver([the_solver], splitter, [downloader])

if args.s:
    challenge, url = downloader.get_audio_url_and_challenge()
else:
    url = "http://www.google.com/recaptcha/api/image?c=" + args.challenge

filename = "current" + str(os.getpid())
if not downloader.get_mp3(url, filename):
    print "Could not download mp3 file"
else:
    print captcha_solver.solve(filename)
